"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TurndownService = require('@joplin/turndown');
const turndownPluginGfm = require('@joplin/turndown-plugin-gfm').gfm;
const markdownUtils_1 = require("./markdownUtils");
class HtmlToMd {
    parse(html, options = {}) {
        const turndown = new TurndownService({
            headingStyle: 'atx',
            anchorNames: options.anchorNames ? options.anchorNames.map(n => n.trim().toLowerCase()) : [],
            codeBlockStyle: 'fenced',
            preserveImageTagsWithSize: !!options.preserveImageTagsWithSize,
            bulletListMarker: '-',
            emDelimiter: '*',
            strongDelimiter: '**',
            br: '',
            disableEscapeContent: 'disableEscapeContent' in options ? options.disableEscapeContent : false,
        });
        turndown.use(turndownPluginGfm);
        turndown.remove('script');
        turndown.remove('style');
        let md = turndown.turndown(html);
        if (options.baseUrl)
            md = markdownUtils_1.default.prependBaseUrl(md, options.baseUrl);
        return md;
    }
}
exports.default = HtmlToMd;
//# sourceMappingURL=HtmlToMd.js.map