"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Setting_1 = require("../models/Setting");
const ItemChange_1 = require("../models/ItemChange");
const dayMs = 86400000;
class ItemChangeUtils {
    static deleteProcessedChanges(itemMinTtl = dayMs * 90) {
        return __awaiter(this, void 0, void 0, function* () {
            const lastProcessedChangeIds = [
                Setting_1.default.value('resourceService.lastProcessedChangeId'),
                Setting_1.default.value('searchEngine.lastProcessedChangeId'),
                Setting_1.default.value('revisionService.lastProcessedChangeId'),
            ];
            const lowestChangeId = Math.min(...lastProcessedChangeIds);
            yield ItemChange_1.default.deleteOldChanges(lowestChangeId, itemMinTtl);
        });
    }
}
exports.default = ItemChangeUtils;
//# sourceMappingURL=ItemChangeUtils.js.map