"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const requestFields_1 = require("./requestFields");
const BaseModel_1 = require("../../../BaseModel");
const requestPaginationOptions_1 = require("./requestPaginationOptions");
const paginatedFeed_1 = require("../../../models/utils/paginatedFeed");
const BaseItem_1 = require("../../../models/BaseItem");
function default_1(modelType, request, whereQuery = null) {
    return __awaiter(this, void 0, void 0, function* () {
        const ModelClass = BaseItem_1.default.getClassByItemType(modelType);
        const fields = (0, requestFields_1.default)(request, modelType);
        const pagination = (0, requestPaginationOptions_1.default)(request);
        return (0, paginatedFeed_1.default)(BaseModel_1.default.db(), ModelClass.tableName(), pagination, whereQuery, fields);
    });
}
exports.default = default_1;
//# sourceMappingURL=paginatedResults.js.map