"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const locale_1 = require("./locale");
const Setting_1 = require("./models/Setting");
const registry_1 = require("./registry");
function versionInfo(packageInfo) {
    const p = packageInfo;
    let gitInfo = '';
    if ('git' in p) {
        gitInfo = (0, locale_1._)('Revision: %s (%s)', p.git.hash, p.git.branch);
        if (p.git.branch === 'HEAD')
            gitInfo = gitInfo.slice(0, -7);
    }
    const copyrightText = 'Copyright © 2016-YYYY Laurent Cozic';
    const now = new Date();
    const header = [
        p.description,
        '',
        copyrightText.replace('YYYY', `${now.getFullYear()}`),
    ];
    const body = [
        (0, locale_1._)('%s %s (%s, %s)', p.name, p.version, Setting_1.default.value('env'), process.platform),
        '',
        (0, locale_1._)('Client ID: %s', Setting_1.default.value('clientId')),
        (0, locale_1._)('Sync Version: %s', Setting_1.default.value('syncVersion')),
        (0, locale_1._)('Profile Version: %s', registry_1.reg.db().version()),
        (0, locale_1._)('Keychain Supported: %s', Setting_1.default.value('keychain.supported') >= 1 ? (0, locale_1._)('Yes') : (0, locale_1._)('No')),
    ];
    if (gitInfo) {
        body.push(`\n${gitInfo}`);
        console.info(gitInfo);
    }
    return {
        header: header.join('\n'),
        body: body.join('\n'),
        message: header.concat(body).join('\n'),
    };
}
exports.default = versionInfo;
//# sourceMappingURL=versionInfo.js.map