"use strict";
// This rule is used to add a media player for certain resource types below
// the link.
Object.defineProperty(exports, "__esModule", { value: true });
const renderMedia_1 = require("../renderMedia");
function plugin(markdownIt, ruleOptions) {
    const defaultRender = markdownIt.renderer.rules.link_close || function (tokens, idx, options, _env, self) {
        return self.renderToken(tokens, idx, options);
    };
    markdownIt.renderer.rules.link_close = function (tokens, idx, options, env, self) {
        const defaultOutput = defaultRender(tokens, idx, options, env, self);
        const link = ruleOptions.context.currentLinks.pop();
        if (!link || ruleOptions.linkRenderingType === 2 || ruleOptions.plainResourceRendering)
            return defaultOutput;
        return [defaultOutput, renderMedia_1.default(link, ruleOptions)].join('');
    };
}
exports.default = { plugin };
//# sourceMappingURL=link_close.js.map